#include <SPI.h>
#include <Ethernet2.h> 
byte mac[]= {0x90,0xA2,0xDA,0x10,0xC5,0x80};
//MAC
IPAddress ip(192,168,1,177);
//IP
EthernetServer servidor(8080);
IPAddress gateway( 192, 168, 1 , 1 );
IPAddress subnet( 255, 255, 255, 0 );
//  Adreça IP del servidor de correu SMPT que emprarem 
IPAddress server( 1, 1, 1,1 ); /
EthernetClient client_smtp;
const byte PIN_aigua=3;
const byte PIN_foc=8;
const byte PIN_rele1=4;
const byte PIN_rele2=5;
const byte PIN_rele3=6;
const byte PIN_rele4=7;

const boolean ON=true;
const boolean OFF=false;
const int Frequencia_enviament_mail=30000;  //establerta en milisegons
boolean state_foc;
boolean state_aigua;
boolean state_anterior_aigua;
boolean state_anterior_foc;
boolean state_aigua_enviat;
boolean state_foc_enviat;
boolean state_gas_enviat;
boolean state_ventilador;
boolean state_gas;
boolean state_anterior_gas;
//boolean canvi;
int valor;
boolean enviat_aigua=false;
boolean enviat_foc=false;
boolean enviat_gas=false;
String enviament=String(5);
 int temps_aigua_si;
  long temps_foc_si;
 long temps_aigua;
  long temps_foc;
  long temps_gas;
  long temps_control;
void setup() {

  //Definim l´estat dels pins de entrada digitals per connectar l´estat foc i aigua
  pinMode(PIN_aigua,INPUT);
  pinMode(PIN_foc,INPUT);

  //Definim l´estat dels pins de sortida per connectar els reles
  pinMode(PIN_rele1, OUTPUT);
  pinMode(PIN_rele2, OUTPUT);
  pinMode(PIN_rele3, OUTPUT);
  pinMode(PIN_rele4, OUTPUT);

  //variables d´estat
  state_anterior_foc=OFF;
  state_foc=OFF;
  state_anterior_aigua=OFF;
  state_aigua=OFF;
  state_ventilador=OFF;
  state_anterior_gas=OFF;
  state_aigua_enviat=state_aigua;
  state_foc_enviat=state_foc;
  //carregem el port serie a 9600 bps
  Serial.begin(9600);
  Serial.println(F("Inici de la aplicacio"));
  //carreguem els servidor http 
  Ethernet.begin(mac, ip);
  servidor.begin();
}

void loop() {
 

  //*******Lectura MQ-7   
  boolean state_gas=Llegir_Analog_MQ7();

  //Lectura Pin digital FOC  I AIGUA 
  boolean state_foc=llegir_digital(PIN_foc);
  boolean state_aigua=llegir_digital(PIN_aigua);
  if (state_gas) {state_ventilador=ON;} //en cas que es detecti gas activarem el ventilador
  //***********************************control canvi
  if (canvi_estat(state_foc,state_anterior_foc)) {
    temps_foc=millis(); 
    enviat_foc=false;
  }
  else
  {
    enviat_foc=control_estat (state_foc,state_anterior_foc,2,temps_foc,enviat_foc,state_foc_enviat);  
    if (enviat_foc) {  
      state_foc_enviat=state_anterior_foc;
      temps_foc=millis();
    }
  }

  if (canvi_estat(state_aigua,state_anterior_aigua)) {
    temps_aigua=millis(); 
    enviat_aigua=false;
  }
  else
  {
    enviat_aigua=control_estat (state_aigua,state_anterior_aigua,1,temps_aigua,enviat_aigua,state_aigua_enviat);  
    if (enviat_aigua) {  
      state_aigua_enviat=state_anterior_aigua;
      temps_aigua=millis();
    }
  }


  if (canvi_estat(state_gas,state_anterior_gas)) {
    temps_gas=millis(); 
    enviat_gas=false;
  }
  else
  {
    enviat_gas=control_estat (state_gas,state_anterior_gas,3,temps_gas,enviat_gas,state_gas_enviat);  
    if (enviat_gas) {  
      state_gas_enviat=state_anterior_gas;
      temps_gas=millis();
    }
  }


  state_anterior_gas=state_gas;   
  state_anterior_aigua=state_aigua;
  state_anterior_foc=state_foc;

  if (state_ventilador)
  {
    digitalWrite(7,HIGH);  
  }
  else
  {
    digitalWrite(7,LOW); 
  }
  //************************************* part de generació HTML i gestio de botons***
  //**********************************************************************************  
  EthernetClient client = servidor.available(); 
  if (client) {
    boolean lineaActual = true; 
    String cadena=""; 
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        // Serial.write(c);
        cadena.concat(c);       
        int posicion=cadena.indexOf("BOTO="); //
        if(cadena.substring(posicion)=="BOTO=01")
        {
          digitalWrite(4,HIGH);
          delay(1000);
          digitalWrite(4,LOW);
        }
        if(cadena.substring(posicion)=="BOTO=02")
        {
          digitalWrite(4,HIGH);
          
          delay(5000);
          digitalWrite(4,LOW);
        }
        if(cadena.substring(posicion)=="BOTO=03")
        {
          digitalWrite(5,HIGH);
          
          delay(1000);
          digitalWrite(5,LOW);
        }

        if(cadena.substring(posicion)=="BOTO=04")
        {
          digitalWrite(6,HIGH);
          delay(1000);
          digitalWrite(6,LOW);
        }
        if(cadena.substring(posicion)=="BOTO=05")
        {
          if (state_ventilador) { state_ventilador=OFF;}
          else
          {
            state_ventilador=ON;
          }
        }
        if (c == '\n' && lineaActual) {
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println();         
          client.println(F("<html>"));
          client.println(F("<head>"));
          client.println("<meta http-equiv=\"refresh\" content=\"5;URL=http://192.168.1.177:8080\">");
          client.println(F("</head>"));
          client.println(F("<body>"));
          client.println(F("<h1 align='center'>CONTROL </h1><h3 align='center'>PARKING</h3>"));
          client.println(F("<div style='text-align:center;'>"));
          client.print("<br>");
          if (state_foc==ON) {
            client.println(" <font color=\"red\">Estat del alarma de foc: Alarma Activada");
            client.println("<font>");
          } else {
            client.println(" <font color=\"green\">Estat del alarma de foc: Correcte ");
            client.print("<font>");
          }
          client.print("<br><br>");
          if (state_aigua==ON) {
            client.println(" <font color=\"red\">Estat del alarma aigua: Alarma Activada");
            client.println("<font>");
          } else {
            client.println(" <font color=\"green\">Estat del alarma de aigua: Correcte ");
            client.println("<font>");
          }
          client.println("<br><br>");
          if (state_gas) {
            client.println(" <font color=\"red\">Estat del alarma de Gas: Alarma Activada");
            client.println("<font>");
          } else {
            client.println(" <font color=\"green\">Estat del alarma de Gas: Correcte ");
            client.print("<font>");
          }
          client.print("<br><br>");
          client.println(F("<button onClick=location.href='./?BOTO=01\' style='margin:auto;background-color: #85aaea;color: snow;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
          client.println(F("Engegar Ordinador"));
          client.println(F("</button>"));
          client.println(F("<button onClick=location.href='./?BOTO=02\' style='margin:auto;background-color: #85aaea;color: snow;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
          client.println(F("Aturar Ordinador"));
          client.println(F("</button>"));
          client.println(F("<br /><br />"));          
          client.println(F("<button onClick=location.href='./?BOTO=03\' style='margin:auto;background-color: #85aaea;color: snow;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
          client.println(F("Obrir Porta de vianants"));
          client.println(F("</button>"));
          client.println(F("<button onClick=location.href='./?BOTO=04\' style='margin:auto;background-color: #85aaea;color: snow;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
          client.println(F("Obrir Porta de Vehicles"));
          client.println(F("</button>"));
          client.println(F("<br /><br />"));
          
          if (state_ventilador==ON){
            client.println(F("<button onClick=location.href='./?BOTO=05\' style='margin:auto;background-color: #ea8f85;color: snow;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
            
            client.println(F("apagar vent"));
          }
          else
          {
            client.println(F("<button onClick=location.href='./?BOTO=05\' style='margin:auto;background-color: #85ea8e;color: black;padding: 10px;border: 1px solid #3F7CFF;width:200px;'>"));
            
            client.println(F("engegar vent"));
          }
          client.println(F("</b><br />"));            
          client.println(F("</b></body>"));
          client.println(F("</html>"));
          break;
        }
        if (c == '\n') {
          lineaActual = true;
        }
        else if (c != '\r') {
          lineaActual = false;
        }
      }
    }
    delay(1);
    client.stop();
  }
}

//*******************************************************************
boolean llegir_digital (int pin){
  //per fer la lectura del pin digital llegirem 10 vegades el valor i el valor que més vegades es llegeixi serà marcarà l´estat
  int valor=0;
  int buttonState=0;
  for (int i=0;i<10;i++)
  {
    buttonState = digitalRead(pin);
    if (buttonState == HIGH) {valor++;}
    delay(10);
  }

  if (valor>4) {return true;}
  return false;
}

//*******************************************************************

byte sendEmail(int enviament,boolean state ) {
  byte thisByte = 0;
  byte respCode;
  if(client_smtp.connect(server,25)) {
    Serial.println(F("connected"));
  } else {
    Serial.println(F("connection failed"));
    return 0;
  }
  if(!eRcv()) return 0;
  Serial.println(F("Sending helo"));
  // change to your public ip
  client_smtp.println(F("helo a.com"));
  if(!eRcv()) return 0;
  client_smtp.println("AUTH LOGIN");
  if(!eRcv()) return 0;
  //Enviem  usuario en base64
  client_smtp.println("11111111111111==");
  if(!eRcv()) return 0;
  //Enviem el password en base64    
  client_smtp.println("2222222222222222=");
  if(!eRcv()) return 0;
  Serial.println(F("Sending From"));
  // enviem l´adreça del remitent
  client_smtp.println(F("MAIL From: alarmes@uoc.com"));
  if(!eRcv()) return 0;
  Serial.println(F("Sending To"));
  client_smtp.println(F("RCPT To: notificacions@gmail.com"));
  if(!eRcv()) return 0;
  Serial.println(F("Sending DATA"));
  client_smtp.println(F("DATA"));
  if(!eRcv()) return 0;
  Serial.println(F("Sending email"));
  client_smtp.println(F("To: dflorga <notificacions@gmail.com>"));
  client_smtp.println(F("From: Alarmes Arduino <notificacions@uoc.com>"));
  Serial.print("enviament es ");
  Serial.println(enviament);
  switch (enviament) {
  case 1:
    {
      Serial.println("enviem mail d´aigua");
      if (state==OFF) {
        client_smtp.println(F("Subject: Alarma Aigua estat OK\r\n"));
        client_smtp.println(F("Estat de aigua correcte!"));
        Serial.println(F("Subject: Alarma Aigua estat OK\r\n"));
        Serial.println(F("Estat de aigua correcte!"));  
        
      } else {
        client_smtp.println(F("Subject: ALARMA AIGUA!!!!!!!!!!! \r\n"));
        client_smtp.println(F("DETECTADA PRESSIO DE AIGUA INCORRECTE!"));
        Serial.println(F("Subject: ALARMA AIGUA!!!!!!!!!!! \r\n"));
        Serial.println(F("DETECTADA PRESSIO DE AIGUA INCORRECTE!"));
      }


    }
    break;
  case 2:
    {
      Serial.println("enviem mail de foc");
      if (state==OFF) {
        client_smtp.println(F("Subject: Alarma FOC estat OK\r\n"));
        client_smtp.println(F("Estat de Alarma de foc correcte!"));
        Serial.println(F("Subject: Alarma FOC estat OK\r\n"));
        Serial.println(F("Estat de Alarma de foc correcte!"));
      } else {
        client_smtp.println(F("Subject: ALARMA FOC!!!!!!!!!!! \r\n"));
        client_smtp.println(F("DETECTADA ALARMA INCENDIS ACTIVADA!"));
        Serial.println(F("Subject: ALARMA FOC!!!!!!!!!!! \r\n"));
        Serial.println(F("DETECTADA ALARMA DE FOCS ACTIVADA!"));
      }
    }
    break;
  case 3:
    {
      if (state==OFF) {
        client_smtp.println(F("Subject: Alarma GAS estat OK\r\n"));
        client_smtp.println(F("Estat de Alarma de GAS correcte!"));
        Serial.println(F("Subject: Alarma GAS estat OK\r\n"));
        Serial.println(F("Estat de Alarma de foc correcte!"));
      } else {
        client_smtp.println(F("Subject: ALARMA GAS!!!!!!!!!!! \r\n"));
        client_smtp.println(F("DETECTADA ALARMA GAS ACTIVADA!"));
        Serial.println(F("Subject: ALARMA GAS!!!!!!!!!!! \r\n"));
        Serial.println(F("DETECTADA EXCES DE MONOXID DE CARBONI!"));
      }
    }
    break;
  }
  client_smtp.println(F("."));
  if(!eRcv()) return 0;
  Serial.println(F("Sending QUIT"));
  client_smtp.println(F("QUIT"));
  if(!eRcv()) return 0;
  client_smtp.stop();
  Serial.println(F("disconnected"));
  return 1;
}

//*******************************************************************
byte eRcv() {
  byte respCode;
  byte thisByte;
  int loopCount = 0;
  while(!client_smtp.available()) {
    delay(1);
    loopCount++;
    if(loopCount > 10000) {
      client_smtp.stop();
      Serial.println(F("\r\nTimeout"));
      return 0;
    }
  }
  respCode = client_smtp.peek();
  while(client_smtp.available()) {
    thisByte = client_smtp.read();
    Serial.write(thisByte);
  }
  if(respCode >= '4') {
    efail();
    return 0;
  }
  return 1;
}

//*******************************************************************
void efail() {
  byte thisByte = 0;
  int loopCount = 0;
  client_smtp.println(F("QUIT"));
  while(!client_smtp.available()) {
    delay(1);
    loopCount++;
    if(loopCount > 10000) {
      client_smtp.stop();
      Serial.println(F("\r\nTimeout"));
      return;
    }
  }
  while(client_smtp.available()) {
    thisByte = client_smtp.read();
    Serial.write(thisByte);
  }
  client_smtp.stop();
  Serial.println(F("disconnected"));
}

//*******************************************************************
boolean Llegir_Analog_MQ7() {
  int MQ7 = analogRead(A0); 
  delay(100);
  if (MQ7>=100) {
    return ON ;   
  }
  return OFF;
}

//*******************************************************************
boolean control_estat (boolean estat_actual,boolean estat_anterior, int enviament, long temps, boolean enviat, boolean estat_enviat)
{

  if (!(enviat && estat_anterior==OFF)) {
    //  versuio optimitzada de if ((no enviat && state_anterior=="OFF") || (state_anterior=="ON")){  
    
    if (estat_enviat==ON || estat_anterior==ON) {
    long temps_control=millis()-temps;
     
      if (temps_control>Frequencia_enviament_mail) {  
       if(sendEmail(enviament,estat_actual)) Serial.println(F("Email sent")); else Serial.println(F("Email failed"));      
        Serial.print(F("enviem mail , enviat a les "));
        Serial.print(millis());
        if (estat_anterior==OFF) {
          Serial.println(F(" no hi haura proper mail a no ser que es canvii d'estat "));
        } else {
          Serial.print(F(" el proper sera a les "));
          Serial.println(millis()+Frequencia_enviament_mail);
        }
        delay(100);
        return true;
      }
    }
  }  
  return false;
}  
//*******************************************************************
boolean canvi_estat (boolean estat_anterior, boolean estat_actual)
{
  return !(estat_anterior==estat_actual) ;
}

